--- src/port/port.tcl.orig	Mon Aug 11 20:33:40 2003
+++ src/port/port.tcl	Mon Aug 11 21:58:26 2003
@@ -172,6 +172,92 @@
 }
 
 switch -- $action {
+    query-dependencies {
+        set nodeps true
+
+        # make sure a port was given on the command line
+	if {![info exists portname]} {
+	    puts "You must specify a port"
+	    exit 1
+	}
+
+        # search for port
+	if {[catch {dportsearch ^$portname$} result]} {
+	    puts "port search failed: $result"
+	    exit 1
+	}
+
+        if {"$result" == ""} {
+            puts "No port $portname found."
+            exit 1
+        }
+
+        # an array is better than a list for this imho
+        array set portinfo [lindex $result 1]
+
+        # find build dependencies
+        if {![catch {set depends_build $portinfo(depends_build)} result]} {
+            puts "$portname has build dependencies on:"
+            foreach i $depends_build {
+                puts "\t[lindex [split [lindex $i 0] :] 2]"
+            }
+            set nodeps false
+        }
+    
+        # find library dependencies
+        if {![catch {set depends_lib $portinfo(depends_lib)} result]} {
+            puts "$portname has library dependencies on:"
+            foreach i $depends_lib {
+                puts "\t[lindex [split [lindex $i 0] :] 2]"
+            }
+            set nodeps false
+        }
+    
+        # find runtime dependencies
+        if {![catch {set depends_run $portinfo(depends_run)} result]} {
+            puts "$portname has runtime dependencies on:"
+            foreach i $depends_run {
+                puts "\t[lindex [split [lindex $i 0] :] 2]"
+            }
+            set nodeps false
+        }
+
+        # no dependencies found
+        if {"$nodeps" == "true"} {
+            puts "$portname has no dependencies"
+        }
+    }
+    query-variants {
+        # make sure a port was given on the command line
+	if {![info exists portname]} {
+	    puts "You must specify a port"
+	    exit 1
+	}
+
+        # search for port
+	if {[catch {dportsearch ^$portname$} result]} {
+	    puts "port search failed: $result"
+	    exit 1
+	}
+
+        if {"$result" == ""} {
+            puts "No port $portname found."
+            exit 1
+        }
+
+        # an array is better than a list for this imho
+        array set portinfo [lindex $result 1]
+
+        # if this fails the port doesn't have any variants
+        if {[catch {set portvariants $portinfo(variants)} result]} {
+            puts "$portname has no variants"
+        } else {
+        # print out all the variants
+            for {set i 0} {$i < [llength $portvariants]} {incr i} {
+                puts "[lindex $portvariants $i]"
+            }
+        }
+    }
     search {
 	if ![info exists portname] {
 	    puts "You must specify a search pattern"
