# portquery-requires.tcl

package provide portquery-requires 1.0

set com.apple.query-requires [target_new com.apple.query-requires query-requires_main]
target_runtype ${com.apple.query-requires} always
target_provides ${com.apple.query-requires} query-requires
target_requires ${com.apple.query-requires} main
target_postrun ${com.apple.query-requires} clean

# right now this doesn't handle variants at all
proc query-requires_main {args} {
    global portname
    set nodeps true

    # search for port
    set res [dportsearch ^$portname$]

    # an array is better than a list for this imho
    array set portinfo [lindex $res 1]

    # find build dependencies
    if {![catch {set depends_build $portinfo(depends_build)} result]} {
        puts "$portname has build dependencies on:"
        foreach i $depends_build {
            puts "\t[lindex [split [lindex $i 0] :] 2]"
        }
        set nodeps false
    }
    
    # find library dependencies
    if {![catch {set depends_lib $portinfo(depends_lib)} result]} {
        puts "$portname has library dependencies on:"
        foreach i $depends_lib {
            puts "\t[lindex [split [lindex $i 0] :] 2]"
        }
        set nodeps false
    }
    
    # find runtime dependencies
    if {![catch {set depends_run $portinfo(depends_run)} result]} {
        puts "$portname has runtime dependencies on:"
        foreach i $depends_run {
            puts "\t[lindex [split [lindex $i 0] :] 2]"
        }
        set nodeps false
    }

    # no dependencies found
    if {"$nodeps" == "true"} {
        puts "$portname has no dependencies"
    }
}

