# portquery-variants.tcl

package provide portquery-variants 1.0

set com.apple.query-variants [target_new com.apple.query-variants query-variants_main]
target_runtype ${com.apple.query-variants} always
target_provides ${com.apple.query-variants} query-variants
target_requires ${com.apple.query-variants} main

proc query-variants_main {args} {
    global portname

    # search for port
    set res [dportsearch ^$portname$]

    # an array is better than a list for this imho
    array set portinfo [lindex $res 1]

    # if this fails the port doesn't have any variants
    if {[catch {set portvariants $portinfo(variants)} result]} {
        puts "$portname has no variants"
        exit 1
    }

    # print out all the variants
    for {set i 0} {$i < [llength $portvariants]} {incr i} {
        puts "[lindex $portvariants $i]"
    }
}

